revert chost, broke for localhost
[automated-distro-installer] / pxe-server
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # This program is free software; you can redistribute it and/or
5 # modify it under the terms of the GNU General Public License
6 # as published by the Free Software Foundation; either version 2
7 # of the License, or (at your option) any later version.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
13
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write to the Free Software
16 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
17
18 # Setup dhcp server to point to tftp server,
19 # and depending on the type, setup the tftp server.
20
21 # usage: $0 TYPE
22 # default distro is the base debian/fedora type. others are fai & arch.
23 # for no pxe server, use a no-op like : or true.
24
25 set -eE -o pipefail
26 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
27
28
29 usage() {
30 cat <<EOF
31 Usage: ${0##*/} [OPTIONS] [HOST TYPE]
32 Configure dnsmasq pxe server options and fai-chboot if appropriate.
33
34
35 Without HOST TYPE, disable pxe server and fai server.
36 TYPE is one of arch, plain, fai.
37 HOST is a hostname known to the dhcp server, or default for all
38 Note, when switching between plain and arch, you will need to
39 do something like:
40 ssh wrt
41 cd /mnt/usb
42 rm tftpboot
43 ln -s <arch/debian iso dir> tftpboot
44
45
46 -r Don't redeploy fai config. For example, if there is a different host
47 that is mid-install.
48
49 -a Don't setup pxe, just Wait for 2 dhcp acks, then disable the pxe
50 server after a delay. First ack is for pxe boot, 2nd ack is
51 for os boot. Sometimes on debian, there is a 3rd one shortly
52 after the 2nd. I can't remember exactly why this caused a
53 problem, but I'm hoping the sleep will take care of it.
54
55 -w Setup pxe, then wait like -a.
56 -h|--help Print help and exit
57
58
59 Note: Uses GNU getopt options parsing style
60 EOF
61 exit $1
62 }
63
64 ##### begin command line parsing ########
65
66 redep=true
67 acks=2
68 wait=false
69 temp=$(getopt -l help harw "$@") || usage 1
70 eval set -- "$temp"
71 while true; do
72 case $1 in
73 -a) wait=true; set=false; shift ;;
74 -r) redep=false; shift ;;
75 -w) wait=true; set=true; shift ;;
76 -h|--help) usage ;;
77 --) shift; break ;;
78 *) echo "$0: Internal error!" ; exit 1 ;;
79 esac
80 done
81
82 read -r host type <<<"$@"
83
84 case $# in
85 0|2);;
86 *)
87 echo "$0: error: expected 0 or 2 arguments"
88 echo
89 usage 1
90 ;;
91 esac
92
93 if [[ $host ]]; then
94 host_tag="tag:$host,"
95 fi
96
97 ##### end command line parsing ########
98
99 e() {
100 echo "$@"
101 "$@"
102 }
103
104 arch() {
105 cat <<EOF
106 dhcp-option-force=209,boot/syslinux/archiso.cfg
107 dhcp-option-force=210,/arch/
108 dhcp-boot=${host_tag}/arch/boot/syslinux/lpxelinux.0
109 EOF
110 }
111
112 plain() {
113 # if arch was used before, this additionally needs
114 # the tftp link in /mnt/usb to be changed.
115 cat <<EOF
116 dhcp-boot=${host_tag}pxelinux.0
117 EOF
118 }
119
120 fai() {
121 cat <<EOF
122 dhcp-boot=${host_tag}pxelinux.0,faiserver.lan,faiserver.lan
123 EOF
124 }
125
126 ack-wait() {
127 wait_count=$1
128 if [[ $host ]]; then
129 host_regex=" $host"
130 fi
131 regex=".*DHCPACK.*$host_regex$"
132 i=0
133 while (( i != wait_count )) && read -r line; do
134 if [[ $line =~ $regex ]]; then
135 i=$((i+1))
136 echo $line
137 fi
138 done < <(ssh wrt logread -f)
139 e sleep 20
140 }
141
142 set-pxe() {
143 ${type:-:}|ssh wrt "cedit pxe /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
144 $([[ $type == arch ]] && echo arch-pxe-mount)"
145 }
146
147
148 if $set; then
149 set-pxe
150 if [[ $type == fai ]]; then
151 e myfai-chboot $host
152 if $redep; then
153 e fai-redep
154 fi
155 else
156 # This will fail if faiserver is not setup, so ignore any
157 # failure and don't bother us about it.
158 myfai-chboot &>/dev/null ||:
159 fi
160 fi
161
162 if $wait; then
163 # fai's debian jessie 8.5ish does 2 dhcp requests when booting,
164 # roughly 4 seconds apart. Earlier
165 # versions did just 1. Now testing on a vm, it does 1.
166 # bleh.
167 echo "waiting for $acks dhcp acks then disabling pxe"
168 ack-wait $acks
169 type=
170 set-pxe
171
172 # previously tried waiting for one more ack then disabling faiserver,
173 # since it can contain sensitive info, so turn it off when not in use,
174 # but disabling that for now as it's inconvenient to clean this
175 # up and run it in the background etc.
176
177 # if [[ $type == fai ]]; then
178 # echo "waiting for 1 dhcp ack then disabling fai server"
179 # ack-wait 1
180 # faiserver-disable
181 # fi
182 fi